#include "FROG_Net_Tools.h"

using namespace std;

bool GetPathFromURL(char* dest, char* inputFile, unsigned int sizeMax, const char* AbsolutePath=NULL)
{
	std::string result((char*)inputFile);
	bool toReturn = false;

	// check if inputVisFile contains http:// or ftp://
	string::size_type loc  = result.find( "http://", 0 );
	string::size_type loc2 = result.find( "ftp://", 0 );		   

	if( loc != string::npos || loc2 != string::npos) {
		 int End = result.rfind('/');			 

		 string local     = result.substr(End+1,result.size());
		 string localPath = string("Files/") + local;		 
		 if(AbsolutePath){			
			 result    = string(AbsolutePath) + localPath;
		 }else{
			 result    = localPath;
		 }

		 #ifdef FROG_CURL
		 toReturn  = true;		 
		 #endif
	}else{		
		if(FROG_PATH::IsFileExist(inputFile)){
			result = string(inputFile);
		}else{
			string tempory = string(inputFile);
			if(AbsolutePath && tempory.find(AbsolutePath)==string::npos){
				result = string(AbsolutePath) + string(inputFile);
			}
		}
	}

	if(result.size()>sizeMax){
		printf("GetPathFromURL : sizeMax is smaller than the actual string size\n");
	}else{
		strcpy(dest,result.c_str());
	}

	return toReturn;		  
}

bool IsExpectedFileSize(char* fileName){
	FILE* FileExist = fopen(fileName,"rb");
	if(!FileExist)return false;

	fseek(FileExist,0,SEEK_SET);
	unsigned short chunk_type     = 0;
	unsigned int   chunk_size     = 0;
	fread(&chunk_type, 1, sizeof(unsigned short), FileExist);
	fread(&chunk_size, 1, sizeof(unsigned int)  , FileExist);
	fseek(FileExist,0,SEEK_END);
	if( (long int)(chunk_size) > ftell(FileExist) ){
		fclose(FileExist);
		return false;
	}	
	fclose(FileExist);
	return true;
}

void* DownLoadFile(void* inputFile,const char* AbsolutePath=NULL)
{
	char* localPath = new char[2048];
	bool IsURL = GetPathFromURL(localPath,(char*)inputFile,2048,AbsolutePath);
	
	if(IsURL){		
		#ifdef FROG_CURL	
		char local[2048];
		strcpy(local,localPath+6);

		//Check if unzipped file (or file, in case of not .gz extension) exist
//		if(!FROG_ZLIB_IsUnZippedFileExist(localPath) || (FROG_ZLIB_IsUnZippedFileExist(localPath) && !CheckFileSize(FileExist)) ){
		if(!FROG_ZLIB_IsUnZippedFileExist(localPath) || (!FROG_ZLIB_IsGZip(localPath) && !IsExpectedFileSize(localPath)) ){			
			printf("Downloading %s to %s\n",(char*)inputFile, local);
			printf("This can take few seconds\n");
			FROG_Net net;
			net.connect((char*)inputFile);
			net.write(localPath);
			net.close();
		}else{
			printf("Loading %s\n",localPath);
		}		
		#endif
	}else{		
		printf("Loading %s\n",localPath);
	}	
	

	if(FROG_ZLIB_IsGZip(localPath)){
		FROG_ZLIB_Inflate(localPath);
	}

	if(!IsExpectedFileSize(localPath) ){
		printf("The (down)loaded File is corrupted\nThis list can help you to find out the problem : \n");
		printf("\t- The .vis file doesn't exist yet\n");
		printf("\t- Bug During the Download! : Clean up the directory File/ of all the .vis file\n");
		printf("\t- Strong firewall : Download the file by yourself and copy it in the File/ repository\n");
		printf("\t- NoIdea : Go on the FROG website http://projects.hepforge.org/frog/\n");
		printf("\t  Download the latest FROG version and/or ask help on the mailing list\n");
		//exit(0);
	}

	return localPath;		  
}


/*
#ifdef windows
	DWORD WINAPI WinDownLoadFile( LPVOID lpParam ) {
		// interface for windows
		char* fileName_ = (char*)lpParam;
		DownLoadFile(fileName_);
		return 0;
	}
#endif
*/

