

#ifndef _FROG_TEXTURE_H__
#define _FROG_TEXTURE_H__

#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) || defined(__NT__)
#  if defined(_MSC_VER)
#    pragma warning(disable:4996)
#  endif
#endif

#ifdef windows 
 #pragma comment (lib,"Includes/ZLIB/Lib/zdll.lib")
 #pragma comment (lib,"Includes/PNGLIB/Lib/libpng13.lib")  
#endif
#include "../PNGLIB/png.h" 


#ifdef linux
 #include <GL/gl.h>
 #include <GL/glu.h>
 #include "../GLUT/glut.h"
#elif macos
 #include <OpenGL/gl.h>
 #include <OpenGL/glu.h>
 #include <GLUT/glut.h>
#else
#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>
#include <gl/glut.h>
#endif
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "../GL2PS/gl2ps.h"


typedef struct stTexture
{
  stTexture () {width=0;height=0;format=0;internalFormat=0;texels=NULL;}

  GLuint   width;
  GLuint   height;
  GLenum   format;
  GLint    internalFormat;
  GLubyte* texels;

} stTexture;

stTexture* VerticalFlipTexture(stTexture* Source);

void LoadTexture(unsigned int* id, const char* strFileName, bool VerticalFlip=false);
void SaveScreenshot(const char* strFileName,unsigned int Width, unsigned int Height, void (*func)(void));

void LoadPNG(stTexture* Texture, const char* strFileName);
void SavePNG(stTexture* Texture, const char* strFileName);


//void SaveBMPScreenshot(char *filename, int Width, int Height);




#endif
